﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using System.Web.Services;
using System.Net;
using Microsoft.SqlServer.Server;

namespace Spatial
{

    public class MpGeocoder
    {

        private static MappointGeocoder.MapPointRef.FindServiceSoap InitFindService()
        {
            MappointGeocoder.MapPointRef.FindServiceSoap findService = new MappointGeocoder.MapPointRef.FindServiceSoap();
            
            // Enter your MapPoint credentials here
            findService.Credentials = new NetworkCredential("**your acct**", "**your password**");  
            findService.PreAuthenticate = true;

            // Uncomment these lines if you use a web proxy server
            //WebProxy myProxy = new WebProxy("http://someproxy:80", true);
            //findService.Proxy = myProxy;
            return findService;
        }

        private static readonly MappointGeocoder.MapPointRef.FindServiceSoap findService = InitFindService();

        [SqlFunction]
        public static string Geocode(string streetAddress)
        {
            string latlong = "POINT EMPTY";

            //Define the address specification for MWS
            MappointGeocoder.MapPointRef.Address myAddress = new MappointGeocoder.MapPointRef.Address();
            myAddress.FormattedAddress = streetAddress;

            //Set the search options
            MappointGeocoder.MapPointRef.FindOptions myFindOptions = new MappointGeocoder.MapPointRef.FindOptions();

            MappointGeocoder.MapPointRef.FindAddressSpecification findAddressSpec =
             new MappointGeocoder.MapPointRef.FindAddressSpecification();
            findAddressSpec.InputAddress = myAddress;
            findAddressSpec.Options = myFindOptions;
            findAddressSpec.DataSourceName = "MapPoint.NA";

            //Set the ResultMask to include the rooftop geocoding values
            findAddressSpec.Options.ResultMask =
                MappointGeocoder.MapPointRef.FindResultMask.RooftopFlag |
                MappointGeocoder.MapPointRef.FindResultMask.LatLongFlag |
                MappointGeocoder.MapPointRef.FindResultMask.EntityFlag |
                MappointGeocoder.MapPointRef.FindResultMask.MatchDetailsFlag |
                MappointGeocoder.MapPointRef.FindResultMask.AddressFlag;

            MappointGeocoder.MapPointRef.FindResults myFindResults;

            myFindResults = findService.FindAddress(findAddressSpec);
            if (myFindResults.NumberFound > 0)
            {
                MappointGeocoder.MapPointRef.FindResult bestResult = myFindResults.Results[0];

                // Return SQL Server 2008 geography WRT (ie, longitude first)
                latlong = "POINT (" + bestResult.BestViewableLocation.LatLong.Longitude
                         + " " + bestResult.BestViewableLocation.LatLong.Latitude + ")";
            }
            return latlong;
        }
    }
}

